/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_PROJLIST_H
#define GWF_PROJLIST_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include "gwf_project.h"

#define GWF_PROJLIST(obj)		GTK_CHECK_CAST(obj, gwf_projlist_get_type (), GwfProjlist)
#define GWF_PROJLIST_CLASS(klass)	GTK_CHECK_CLASS_CAST(klass, gwf_project_get_type (), GefProjectClass)
#define GWF_IS_PROJLIST(obj)		GTK_CHECK_TYPE(obj, gwf_project_get_type())

typedef struct _GwfProjlist		GwfProjlist;
typedef struct _GwfProjlistClass	GwfProjlistClass;

typedef void	(*GwfProjlistForeachFunc)	(GwfProject *project,gpointer user_data);

struct _GwfProjlist
{
  GtkObject	parent;
  
  GList		*projects;
  GwfProject	*current;
  gint		changed;
  gint		idcount;
};

struct _GwfProjlistClass
{
  GtkObjectClass	parent_class;
  
  void	(*project_added)	(GwfProjlist *projlist, gchar *name);
  void	(*project_removed)	(GwfProjlist *projlist, gchar *name);
  void	(*curproj_changed)	(GwfProjlist *projlist, gchar *name);
};

guint		gwf_projlist_get_type		(void);
GwfProjlist*	gwf_projlist_new		(void);

gint		gwf_projlist_new_unique_project	(GwfProjlist *projlist);
gint		gwf_projlist_new_project	(GwfProjlist *projlist, gchar *name);
gint		gwf_projlist_add_project	(GwfProjlist *projlist, GwfProject *project);
void		gwf_projlist_remove_project	(GwfProjlist *projlist, gchar *name);
GwfProject*	gwf_projlist_get_project	(GwfProjlist *projlist, gchar *name);
gint		gwf_projlist_project_changed	(GwfProjlist *projlist);
void		gwf_projlist_project_foreach	(GwfProjlist *projlist,GwfProjlistForeachFunc func,gpointer user_data);
gchar*		gwf_projlist_unique_widname	(GwfProjlist *projlist);
gint		gwf_projlist_project_change_name(GwfProjlist *projlist, gchar *oldname, gchar *newname);
void		gwf_projlist_set_current	(GwfProjlist *projlist, gchar *name);
GwfProject*	gwf_projlist_get_current	(GwfProjlist *projlist);
gint		gwf_projlist_project_is_current	(GwfProjlist *projlist,GwfProject *project);

#ifdef __cplusplus
}
#endif

#endif

